/*
 *  <Short Description>
 *  Copyright (C) 2024  Brett Terpstra
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <blt/gfx/loader/obj_loader.h>
#include <blt/std/loader.h>
#include <blt/std/string.h>
#include <blt/std/logging.h>

namespace blt::gfx
{
    class char_tokenizer
    {
        private:
            std::string_view string;
            std::size_t current_pos = 0;
        public:
            explicit char_tokenizer(std::string_view view): string(view)
            {}
            
            char peek()
            {
                return string[current_pos];
            }
            
            char advance()
            {
                return string[current_pos++];
            }
            
            bool has_next(size_t offset = 0)
            {
                return current_pos + offset < string.size();
            }
    };
    
    std::vector<obj_object_t> quick_load(std::string_view file)
    {
        std::vector<obj_object_t> objects;
        
        
        return objects;
    }
    
    void obj_loader::parseFile(std::string_view file)
    {
        auto lines = blt::fs::getLinesFromFile(std::string(file));
        for (const auto& line : lines)
        {
            char_tokenizer token(line);
            // line is empty?
            if (!token.has_next())
                continue;
            switch (token.advance())
            {
                case '#':
                    continue;
                case 'f':
                {
                    
                    break;
                }
                case 'v':
                {
                    
                    break;
                }
                case 'o':
                {
                
                }
            }
        }
    }
    
    void obj_loader::parse_face(std::string_view line)
    {
    
    }
}